#define MAX_QUERIES_100 3000
#define MAX_QUERIES_20 12000

static const int MAXN = 160;

static int n, m;
static int a[MAXN], b[MAXN], c[MAXN], d[MAXN];

#include "flowers.h"

#include <cstdio>
#include <cstdlib>
#include <cassert>
static int cnt = 0;
int count_different(const std::vector<int>& v)
{
    if (v.size() == 0)
    {
		fprintf(stdout, "Empty question\n");
		printf("0\n");
        exit(0);
    }

    if (cnt == MAX_QUERIES_20)
    {
        fprintf(stdout, "Too many questions\n");
        printf("0.0\n");
        exit(0);
    }
    if (v.size() > n)
    {
        fprintf(stdout, "Question is not valid\n");
        printf("0\n");
        exit(0);
    }

    for (int i = 0; i <= n; ++ i) c[i] = d[i] = 0;
    int ans=0;
    for (int i = 0; i < v.size(); ++ i)
    {
        int x=v[i];
        if (x < 0 or x >= n or d[x] == 1)
        {
            fprintf(stdout, "Question is not valid\n");
            printf("0\n");
            exit(0);
        }
        if (c[a[x]] == 0)
        {
            c[a[x]] = 1;
            ans++;
        }
        d[x] = 1;
    }

    cnt++;
    return ans;
}

void submit_colours(const std::vector<int>& v)
{
    if (v.size() != n)
    {
        fprintf(stdout, "Contestant's answer is not valid\n");
        printf("0\n");
        exit(0);
    }

    for (int i = 0; i < n; ++ i)
    {
        if (v[i] < 1 or v[i] > m)
        {
            fprintf(stdout, "Contestant's answer is not valid\n");
            printf("0\n");
            exit(0);
        }
        b[i]=v[i];
    }

    for (int i = 0; i < n; ++ i)
    {
        for (int j = i + 1; j < n; ++ j)
        {
            if ((a[i] == a[j] and b[i] != b[j]) or (a[i] != a[j] and b[i] == b[j]))
            {
                fprintf(stdout, "Colours of flowers are not correctly assigned\n");
                printf("0\n");
                exit(0);
            }
        }
    }

    if (cnt <= MAX_QUERIES_100)
    {
        fprintf(stdout, "Correct with fewer than 3000 questions\n");
        printf("1.0\n");
    }
    if (cnt > MAX_QUERIES_100)
    {
        fprintf(stdout, "Correct with more than 3000 questions\n");
        printf("0.2\n");
    }
    exit(0);
}


int main()
{
    scanf("%d", &n);

    for (int i = 0; i < n; ++ i)
    {
        scanf("%d", &a[i]);
        if (c[a[i]] == 0)
        {
            c[a[i]] = 1;
            m++;
        }
    }
    play(n);
    return 0;
}
