#include "corridor.h"

/*
memory:
memory[0] - currState
    init = 0
    forward = 1
    backward = 2
memory[1] - currK
memory[2] - targetK
memory[3] - initialCell
*/

/*
states:

init // mem[0] == 0
    currK = 0 // mem[1] = 0
    targetK = 1 // mem[2] = 1
    initialCell = cellValue // mem[3] = cellValue
    currState = forward // mem[0] = 1
    ++currK // ++mem[1]
    STEP RIGHT

forward // mem[0] == 1
    if currK < targetK // mem[1] < mem[2]
        ++currK // ++mem[1]
        STEP RIGHT
    else
        // toggle
        currState = backward // mem[0] = 2
        STEP TOGGLE
backward // mem[0] == 2
    if currK > 0 // mem[1] > 0
        --currK // --mem[1]
        STEP LEFT
    else
        if cellValue != initialCell // cellValue != mem[3]
            STEP ANSWER (targetK) // mem[2]
        else
            ++targetK // mem[2]
            currState = forward // mem[0] = 1
            ++currK // ++mem[1]
            STEP RIGHT
*/

step solve(char cellValue) {
    int currState = get_memory(0);

    if(currState == 0) {
        set_memory(1, 0);
        set_memory(2, 1);
        set_memory(3, cellValue);
        set_memory(0, 1);
        set_memory(1, get_memory(1) + 1);

        return {'r', 0};
    }
    else if(currState == 1) {
        if(get_memory(1) < get_memory(2)) {
            set_memory(1, get_memory(1) + 1);
            return {'r', 0};
        }
        else {
            set_memory(0, 2);
            return {'t', 0};
        }
    }
    else if(currState == 2) {
        if(get_memory(1) > 0) {
            set_memory(1, get_memory(1) - 1);
            return {'l', 0};
        }
        else {
            if(cellValue != get_memory(3)) {
                return {'a', get_memory(2)};
            }
            else {
                set_memory(2, get_memory(2) + 1);
                set_memory(0, 1);
                set_memory(1, get_memory(1) + 1);
                return {'r', 0};
            }
        }
    }
}
