#include<iostream>
#include<string>
#include<sys/signal.h>
#include "manager.h"
using namespace std;
const int PROCESSES=1;
const int MAX_CHECKS=100;
void output_message (int num, string message) {
    cout << num << endl << message << endl ;
    exit(0);
}
int main (int argc, char** argv) {
    signal(SIGPIPE,SIG_IGN);
    fd_to_stream(argv+1,2*PROCESSES);
    int n,m;
    cin >> n >> m ;
    // We shift data so that if participant reads our input, he doesn't learn correct p and v values ;)
    int p,v;
    cin >> p >> v ;
    p = (p + 239) % (n + 1);
    v = (v + 239) % (m + 1);
    if (!(out(0) << n << " " << m << endl )) output_message(-1,"Error writing initial data!");
    int nChecks = 0;
    string s;
    while (true) {
        if (!(in(0) >> s )) output_message(-1,"Error reading command!");
        if (s=="check") {
            int l,r;
            if (!(in(0) >> l >> r )) output_message(-1,"Error reading interval for check command!");
                if ((r < l) || (l < 0) || (r > 1e9)) output_message(-1,"Invalid interval!");
                nChecks++;
                if (nChecks > MAX_CHECKS) output_message(-1,"Too many checks!");
                if (l <= p && p <= r) {
                    if (!(out(0) << "Yes" << endl )) output_message(-1,"Error writing answer to check command!");
                }
                else {
                    if (!(out(0) << "No" << endl )) output_message(-1,"Error writing answer to check command!");
                }
            } else if (s=="answer") {
                int x;
                if (!(in(0) >> x)) output_message(-1,"Error reading position for answer command!");
                if (x == p) output_message(nChecks,"OK!");
                else output_message(-1,"Wrong position");
            } else output_message(-1,"Invalid command name!");
        p += v;
    }
    cout << endl ;
    return 0;
}
