#include "xylophone2.h"
#include<iostream>
#include<set>
#define MAXN 250
#define LOGN 8
using namespace std;
vector <int> all_diffs;
int max_diff (int to) {
    vector <int> inds;
    for (int i=0; i<=to; i++) {
        inds.push_back(i+1);
    }
    auto res=query(inds);
    int max1=0;
    for (auto diff : res) {
        max1=max(max1,diff);
    }
    if (all_diffs.size()==0) all_diffs=res;
    return max1;
}
vector <int> calc_diffs (vector <int> inds, int pos) {
    /*for (auto ind : inds) {
        cout << ind << " ";
    } cout << endl ;*/
    vector <int> res1;
    int k=inds.size();
    if (k>1) res1=query(inds);
    inds.push_back(pos);
    k++;
    vector <int> res2;
    if (k*(k-1)/2==all_diffs.size()) res2=all_diffs;
    else res2=query(inds);
    multiset <int> nums;
    for (auto num : res2) {
        nums.insert(num);
    }
    for (auto num : res1) {
        nums.erase(nums.find(num));
    }
    vector <int> diffs;
    for (auto num : nums) {
        diffs.push_back(num);
    }
    /*for (auto diff : diffs) {
        cout << diff << " ";
    } cout << endl << endl ;*/
    return diffs;
}
vector <int> inds[LOGN];
int max_dep;
void pre_find_diffs (vector <int>& curr_inds, int dep) {
    int k=curr_inds.size();
    if (k==1) return ;
    max_dep=dep;
    vector <int> l,r;
    for (int i=0; i<k; i++) {
        if (i<k/2) {
            l.push_back(curr_inds[i]);
            inds[dep].push_back(curr_inds[i]);
        }
        else r.push_back(curr_inds[i]);
    }
    pre_find_diffs(l,dep+1);
    pre_find_diffs(r,dep+1);
}
vector <int> levels[LOGN];
int diffs[MAXN];
void find_diffs (vector <int>& inds, vector <int> nums, int dep) {
    int k=inds.size();
    if (k==1) {
        diffs[inds[0]-1]=nums[0];
        return ;
    }
    vector <int> l,r;
    for (int i=0; i<k; i++) {
        if (i<k/2) l.push_back(inds[i]);
        else r.push_back(inds[i]);
    }

    set <int> temp;
    for (auto num : nums) {
        temp.insert(num);
    }
    for (auto num : levels[dep]) {
        temp.erase(num);
    }
    vector <int> r_nums;
    for (auto num : temp) {
        r_nums.push_back(num);
    }
    find_diffs(r,r_nums,dep+1);

    set <int> all;
    for (auto num : nums) {
        all.insert(num);
    }
    for (auto num : temp) {
        all.erase(num);
    }
    vector <int> l_nums;
    for (auto num : all) {
        l_nums.push_back(num);
    }
    find_diffs(l,l_nums,dep+1);
}

vector <int> solve (int n) {
    int diff=max_diff(n-1);
    if (n==2) {
        return {1,diff+1};
    }

    int l=0,r=n-1,mid;
    for (;;) {
        if (l==r-1) break;
        mid=(l+r)/2;
        if (max_diff(mid)<diff) l=mid;
        else r=mid;
    }
    vector <int> all;
    for (int i=1; i<=n; i++) {
        if (i==r+1) continue;
        all.push_back(i);
    }
    pre_find_diffs(all,0);
    for (int i=0; i<=max_dep; i++) {
        levels[i]=calc_diffs(inds[i],r+1);
    }
    diffs[r]=0;
    find_diffs(all,calc_diffs(all,r+1),0);

    vector <int> ans(n);
    for (int i=0; i<n; i++) {
        ans[i]=(diff+1)-diffs[i];
        //cout << ans[i] << " ";
    }
    return ans;
}
