/* the checker has three arguments:
   - first - name of the input file
   - second - name of the correct output file
   - third - name of the contestant output file */
#include<iostream>
#include<string.h>
#include<stdio.h>
using namespace std;
void output_message (double points, const char message[]) {
    fprintf(stdout,"%f\n",points);
    fprintf(stderr,"%s\n",message);
    exit(0);
}
int main (int argc, char** argv) {
    FILE *inp,*ans,*out;
    if (argc<4) output_message(0,"The checker needs input file, correct output and contestant output!");
    inp=fopen(argv[1],"rt");
    if (!inp) output_message(0,"Could not open input file!");
    ans=fopen(argv[2],"rt");
    if (!ans) output_message(0,"Could not open correct output file!");
    out=fopen(argv[3],"rt");
    if (!out) output_message(0,"Could not open contestant output file!");

    int n,subtask;
    if (fscanf(inp,"%d%d",&subtask,&n)!=2) output_message(0,"Error reading!");
    int cnt;
    if (fscanf(out,"%d",&cnt)!=1) output_message(0,"Error reading!");
    cnt^=n^subtask;
    if (cnt<-1) output_message(0,"Protocol violation!");
    else if (cnt==-1) output_message(0,"Too many attempts!");
    else if (cnt==0) output_message(0,"Wrong number!");

    double res;
    int author_cnt;
    if (fscanf(ans,"%d",&author_cnt)!=1) output_message(0,"Error reading!");
    if (subtask==3) res=min(1.-min((cnt-author_cnt)/32.,1.),1.);
    else res=min(double(author_cnt)/cnt,1.);
    output_message(res,"OK!");
    return 0;
}
